﻿
using System;
using Wisej.Web;

namespace DesignAtRuntime
{
    public partial class Window1 : Form
    {
        public bool MyDesingMode { get; set; }

        public Window1()
        {
            InitializeComponent();
        }

        private void Window1_ToolClick(object sender, ToolClickEventArgs e)
        {
            if (e.Tool.Name == "designMode")
            {                
                MyDesingMode = !MyDesingMode;
                //update ComponentTools color
                if (MyDesingMode)
                {
                    if (e.Tool.ImageSource.EndsWith("black"))
                    {
                        e.Tool.ImageSource = e.Tool.ImageSource.Replace("black", "red");
                    }
                    else
                    {
                        e.Tool.ImageSource += "?color=red";
                    }                    
                }
                else
                {
                    e.Tool.ImageSource = e.Tool.ImageSource.Replace("red", "black");
                }
                
                //make each control movebale and resizeable
                //this foreach only handle the controls from the forms ControlCollection
                //when you also want to handle Controls in other containers, your must handle it seperate or make a recursion call of this foreach
                foreach (Control control in this.Controls)
                {
                    control.Movable = MyDesingMode;
                   
                    if (MyDesingMode)
                    {
                        control.Move += Control_Move;
                        control.Resize += Control_Resize;
                        control.ResizableEdges = AnchorStyles.Bottom | AnchorStyles.Left | AnchorStyles.Right | AnchorStyles.Top;
                    }
                    else
                    {
                        control.Move -= Control_Move;
                        control.Resize -= Control_Resize;
                        control.ResizableEdges = AnchorStyles.None;
                    }

                }
            }

            

        }

        private void Control_Resize(object sender, EventArgs e)
        {
            //save mew size

            System.Diagnostics.Debug.WriteLine("Size: " + (sender as Control).Size);
        }

        private void Control_Move(object sender, EventArgs e)
        {
            //save new location

            System.Diagnostics.Debug.WriteLine("Location : " + (sender as Control).Location);
        }

    }
}
